/* Рекурсія - це коли ми всередині функції викликаємо цю саму функцію. Так, за рахунок зменшення
аргумента, рекурсія замінює цикл. Її використовують для того, щоб звести функцію до простіших дій.
Окрім того, рекурсивне рішення зазвичай більш коротке. */


let num = prompt("Enter your number.");
while (num === "" || isNaN(num)) {
    num = prompt("Enter your number.", num);
}

function fact(a) {
    return (a == 0 || a === 1) ? 1 : a * fact(a-1);
}
alert(num + "!=" + fact(num));
